Subject: RE: bug#11939: 24.1; `save-buffers-kill-emacs' loses minibuffer focus when itcalls `list-processes'

From: "Drew Adams" <[email-masked]>
Date: Sun, 22 Jul 2012 09:55:51 -0700

>  >> Usually, each frame must have a minibuffer window.  How 
>  >> else should `read-minibuffer' work?
>  >
>  > It can read from the minibuffer in a standalone minibuffer frame?
> 
> Is this a question or an answer?

An answer, followed by "Is that not correct?", since I'm not sure we're talking
about the same thing.  I would expect that it is obvious to you too that Emacs
can read from a minibuffer in a standalone frame.  And it's not clear to me why
that possibility is not an answer to your question.

Keep in mind that I do not understand windows, including minibuffer windows, at
the level you do.

>  > That's what I was guessing, that a frame's `minibuffer' 
>  > parameter might be non-nil but it somehow has a minibuffer 
>  > _window_.  Seems odd, but I guess these things are at two
>  > different levels.  I am used to the Lisp & frame level - I
>  > know almost nothing about the C & window level.
> 
> Emacs must be able to work internally even if you make all your frames
> minibuffer-less.

I never claimed otherwise.  But I don't see the relation here.  And I do not
make all my frames minibuffer-less.  So I guess I'm not following you very well.

>  >> `mouse-leave-buffer-hook' and in a `pre-' or
>  >> `post-command-hook' check whether that something got executed.
>  >> Then you can be sure that somewhere in between a
>  >> `handle-switch-frame' interfered.
>  >
>  > Sorry, I don't follow you (and I haven't found where you 
>  > suggested something similar earlier).  If you can be more
>  > specific I'll be glad to try whatever you ask.
> 
> When you want to check of `handle-switch-frame' executions you cannot
> trace otherwise and you do not run emacs in the debugger, the most
> simple way to trace these is to put some function on
> `mouse-leave-buffer-hook', and inspect the output of that 
> function later on.

OK, but I still do not know what you would like me to do/test.  Can you give me
a recipe to test?

> I see.  On first reading I missed the term "explictly".  IIUC what we
> need is a mechansim that switches frames implicitly to the minibuffer
> frame.

Yes, I think so.  But the trick might be to do this only when it should be done.